Index: /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Controllers/AdminController.cs
===================================================================
--- /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Controllers/AdminController.cs	(revision 6217)
+++ /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Controllers/AdminController.cs	(revision 6218)
@@ -12,8 +12,6 @@
 using HLWebOKBAdminPlugin.Models;
 
-namespace HLWebOKBAdminPlugin.Controllers
-{
-    public class AdminController : Controller
-    {
+namespace HLWebOKBAdminPlugin.Controllers {
+    public class AdminController : Controller {
         private AdministrationServiceClient CertificateValidator() {
             AdministrationServiceClient asc = new AdministrationServiceClient();
@@ -39,5 +37,5 @@
             AdminModel am = new AdminModel();
             Session["SelectedSubMenu"] = "AlgorithmClass";
-            var algorithmClasses = am.AlgorithmClassGetAll();            
+            var algorithmClasses = am.AlgorithmClassProp;
 
             return View(algorithmClasses);
Index: /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/HLWebOKBAdminPlugin.csproj
===================================================================
--- /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/HLWebOKBAdminPlugin.csproj	(revision 6217)
+++ /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/HLWebOKBAdminPlugin.csproj	(revision 6218)
@@ -50,6 +50,5 @@
   </PropertyGroup>
   <ItemGroup>
-    <Reference Include="HLWebPluginHost, Version=1.0.0.0, Culture=neutral, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
+    <Reference Include="HLWebPluginHost">
       <HintPath>..\HeuristicLabWeb.PluginHost\HLWebPluginHost\bin\HLWebPluginHost.dll</HintPath>
     </Reference>
@@ -89,4 +88,5 @@
   <ItemGroup>
     <Compile Include="Controllers\AdminController.cs" />
+    <Compile Include="Controllers\AlgorithmController.cs" />
     <Compile Include="Controllers\HomeController.cs" />
     <Compile Include="Controllers\ProblemController.cs" />
@@ -99,4 +99,5 @@
     <Compile Include="Models\AdminModel.cs" />
     <Compile Include="Models\AlgorithmClassModel.cs" />
+    <Compile Include="Models\AlgorithmModel.cs" />
     <Compile Include="Models\ProblemModel.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
@@ -142,4 +143,6 @@
     <Content Include="Views\Admin\Problem.aspx" />
     <Content Include="Views\Admin\ProblemClass.aspx" />
+    <Content Include="Views\Algorithm\Detail.aspx" />
+    <Content Include="Views\Algorithm\Index.aspx" />
     <Content Include="Views\Home\About.aspx" />
     <Content Include="Views\Home\Index.aspx" />
Index: /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Models/AdminModel.cs
===================================================================
--- /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Models/AdminModel.cs	(revision 6217)
+++ /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Models/AdminModel.cs	(revision 6218)
@@ -15,5 +15,5 @@
         public IList<AlgorithmClass> AlgorithmClassProp { get { return AlgorithmClassGetAll(); } set { ;} }
 
-       
+
         //***************************************Algorithm Class********************************************
         //get all algorithm classes
@@ -23,7 +23,7 @@
             algorithmClassList = new List<AlgorithmClass>();
 
-            if (adminClient != null) {
+            if(adminClient != null) {
                 AlgorithmClass[] algorithmClasses = adminClient.GetAlgorithmClasses();
-                foreach (AlgorithmClass ac in algorithmClasses) {
+                foreach(AlgorithmClass ac in algorithmClasses) {
                     algorithmClassList.Add(ac);
 
@@ -37,5 +37,5 @@
             AdministrationServiceClient adminClient = Admin.GetClientFactory();
 
-            if (adminClient != null) {
+            if(adminClient != null) {
                 return adminClient.AddAlgorithmClass(algorithmClass);
             }
@@ -47,5 +47,5 @@
             AdministrationServiceClient adminClient = Admin.GetClientFactory();
 
-            if (adminClient != null){
+            if(adminClient != null) {
                 adminClient.DeleteAlgorithmClass(id);
             }
@@ -55,12 +55,11 @@
             AdministrationServiceClient adminClient = Admin.GetClientFactory();
 
-            if (adminClient != null) {
-                if (algorithmClass.Id == 0) {
+            if(adminClient != null) {
+                if(algorithmClass.Id == 0) {
                     return AddAlgorithmClass(algorithmClass);
-                }
-                else {
+                } else {
                     AlgorithmClass ac = adminClient.GetAlgorithmClass(algorithmClass.Id);
 
-                    if (ac != null) {
+                    if(ac != null) {
                         adminClient.UpdateAlgorithmClass(algorithmClass);
                         return algorithmClass.Id;
@@ -79,7 +78,7 @@
             IList<Algorithm> algorithmList = new List<Algorithm>();
 
-            if (adminClient != null) {
+            if(adminClient != null) {
                 Algorithm[] algorithm = adminClient.GetAlgorithms();
-                foreach (Algorithm al in algorithm) {
+                foreach(Algorithm al in algorithm) {
                     algorithmList.Add(al);
 
@@ -93,5 +92,5 @@
             AdministrationServiceClient adminClient = Admin.GetClientFactory();
 
-            if (adminClient != null) {
+            if(adminClient != null) {
                 return adminClient.AddAlgorithm(algorithm);
             }
@@ -103,5 +102,5 @@
             AdministrationServiceClient adminClient = Admin.GetClientFactory();
 
-            if (adminClient != null) {
+            if(adminClient != null) {
                 adminClient.DeleteAlgorithm(id);
             }
@@ -111,12 +110,11 @@
             AdministrationServiceClient adminClient = Admin.GetClientFactory();
 
-            if (adminClient != null) {
-                if (algorithm.Id == 0) {
+            if(adminClient != null) {
+                if(algorithm.Id == 0) {
                     return AddAlgorithm(algorithm);
-                }
-                else {
+                } else {
                     Algorithm al = adminClient.GetAlgorithm(algorithm.Id);
 
-                    if (al != null) {
+                    if(al != null) {
                         adminClient.UpdateAlgorithm(algorithm);
                         return algorithm.Id;
@@ -134,7 +132,7 @@
             IList<ProblemClass> problemClassList = new List<ProblemClass>();
 
-            if (adminClient != null) {
+            if(adminClient != null) {
                 ProblemClass[] problemClasses = adminClient.GetProblemClasses();
-                foreach (ProblemClass pc in problemClasses) {
+                foreach(ProblemClass pc in problemClasses) {
                     problemClassList.Add(pc);
                 }
@@ -147,5 +145,5 @@
             AdministrationServiceClient adminClient = Admin.GetClientFactory();
 
-            if (adminClient != null) {
+            if(adminClient != null) {
                 return adminClient.AddProblemClass(problemClass);
             }
@@ -157,5 +155,5 @@
             AdministrationServiceClient adminClient = Admin.GetClientFactory();
 
-            if (adminClient != null) {
+            if(adminClient != null) {
                 adminClient.DeleteProblemClass(id);
             }
@@ -165,12 +163,11 @@
             AdministrationServiceClient adminClient = Admin.GetClientFactory();
 
-            if (adminClient != null) {
-                if (problemClass.Id == 0) {
+            if(adminClient != null) {
+                if(problemClass.Id == 0) {
                     return AddProblemClass(problemClass);
-                }
-                else {
+                } else {
                     ProblemClass pc = adminClient.GetProblemClass(problemClass.Id);
 
-                    if (pc != null) {
+                    if(pc != null) {
                         adminClient.UpdateProblemClass(problemClass);
                         return problemClass.Id;
@@ -188,7 +185,7 @@
             IList<Problem> problemList = new List<Problem>();
 
-            if (adminClient != null) {
+            if(adminClient != null) {
                 Problem[] problem = adminClient.GetProblems();
-                foreach (Problem pr in problem) {
+                foreach(Problem pr in problem) {
                     problemList.Add(pr);
 
@@ -202,5 +199,5 @@
             AdministrationServiceClient adminClient = Admin.GetClientFactory();
 
-            if (adminClient != null) {
+            if(adminClient != null) {
                 return adminClient.AddProblem(problem);
             }
@@ -212,5 +209,5 @@
             AdministrationServiceClient adminClient = Admin.GetClientFactory();
 
-            if (adminClient != null) {
+            if(adminClient != null) {
                 adminClient.DeleteProblem(id);
             }
@@ -220,16 +217,15 @@
             AdministrationServiceClient adminClient = Admin.GetClientFactory();
 
-            if (adminClient != null) {
-                if (problem.Id == 0) {
+            if(adminClient != null) {
+                if(problem.Id == 0) {
                     return AddProblem(problem);
-                }
-                else {
+                } else {
                     Problem pr = adminClient.GetProblem(problem.Id);
 
-                    if (pr != null) {
+                    if(pr != null) {
                         adminClient.UpdateProblem(problem);
                         return problem.Id;
                     }
-                }                
+                }
             }
 
Index: /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Web.config
===================================================================
--- /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Web.config	(revision 6217)
+++ /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Web.config	(revision 6218)
@@ -110,4 +110,20 @@
           </security>
         </binding>
+        <binding name="AdministrationService2" closeTimeout="00:01:00"
+          openTimeout="00:01:00" receiveTimeout="00:10:00" sendTimeout="00:01:00"
+          bypassProxyOnLocal="false" transactionFlow="false" hostNameComparisonMode="StrongWildcard"
+          maxBufferPoolSize="524288" maxReceivedMessageSize="65536" messageEncoding="Text"
+          textEncoding="utf-8" useDefaultWebProxy="true" allowCookies="false">
+          <readerQuotas maxDepth="32" maxStringContentLength="8192" maxArrayLength="16384"
+            maxBytesPerRead="4096" maxNameTableCharCount="16384" />
+          <reliableSession ordered="true" inactivityTimeout="00:10:00"
+            enabled="false" />
+          <security mode="Message">
+            <transport clientCredentialType="Windows" proxyCredentialType="None"
+              realm="" />
+            <message clientCredentialType="UserName" negotiateServiceCredential="true"
+              algorithmSuite="Default" />
+          </security>
+        </binding>
       </wsHttpBinding>
     </bindings>
@@ -127,4 +143,11 @@
         </identity>
       </endpoint>
+      <endpoint address="http://services.heuristiclab.com/OKB.SPR-3.3/AdministrationService.svc"
+        binding="wsHttpBinding" bindingConfiguration="AdministrationService2"
+        contract="OKBAdministrationService.IAdministrationService" name="AdministrationService2">
+        <identity>
+          <certificate encodedValue="AwAAAAEAAAAUAAAAwK1+2oAmcy/mI2P2QjyiJRh0y60gAAAAAQAAACoCAAAwggImMIIBj6ADAgECAhAIkseQ2EEhgU720qJA61gqMA0GCSqGSIb3DQEBBAUAMCQxIjAgBgNVBAMTGXNlcnZpY2VzLmhldXJpc3RpY2xhYi5jb20wHhcNMTAwNTExMTExNDAyWhcNMzkxMjMxMjM1OTU5WjAkMSIwIAYDVQQDExlzZXJ2aWNlcy5oZXVyaXN0aWNsYWIuY29tMIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCq26Bwmwc7k+4W30qLQ2j+FInEL5BuH6opDY6CSlrtt3xQS/anrhvpbf3QghLDVINzcHkzbPmm/SguG4F85QLB6xO+tJaOvRo0iEK5g3c307vMIru7FJwk/OhplEQ5J1hbDgL3zOJlrWlgtqRVxCtVdF3XroI9BctOt1NkeKv9ewIDAQABo1kwVzBVBgNVHQEETjBMgBCjbgdYd4j5JgUuJ1Wo/GxroSYwJDEiMCAGA1UEAxMZc2VydmljZXMuaGV1cmlzdGljbGFiLmNvbYIQCJLHkNhBIYFO9tKiQOtYKjANBgkqhkiG9w0BAQQFAAOBgQAb/2xk2uQad68shSPl/uixWgvFI8WkxOTBopOLaLtDxwCeZ3mWVHdV9VnixHtThubnEBXAhYOCQSIXWtQuXFWO+gH3YyjTRJY5kTmXyuvBRTn3/so5SrQ7Rdlm9hf6E5YVX3tCjAy7ybUyaDUkQfmH5vmvgvpMzRfsJ1qhnUpJiQ==" />
+        </identity>
+      </endpoint>
     </client>
   </system.serviceModel>