Index: branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/Storable/Descriptors/FieldDescriptor.cs
===================================================================
--- branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/Storable/Descriptors/FieldDescriptor.cs	(revision 6220)
+++ branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/Storable/Descriptors/FieldDescriptor.cs	(revision 6221)
@@ -20,9 +20,6 @@
 #endregion
 using System;
-using System.Collections.Generic;
-using System.Linq;
 using System.Reflection;
 using System.Text;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Persistence.Default.CompositeSerializers.Storable.Descriptors {
@@ -35,5 +32,5 @@
 
     #region Fields & Properties
-    
+
     /// <summary>
     /// The type that declared this field.
@@ -75,13 +72,11 @@
     public FieldInfo Handle {
       get {
-        try {
-          if (handle == null)
-            handle = DeclaringType.Handle.GetField(RealName, BindingFlags.Instance | BindingFlags.Public | BindingFlags.NonPublic);
-        } catch { }
+        if (handle == null)
+          handle = DeclaringType.Handle.GetField(RealName, BindingFlags.Instance | BindingFlags.Public | BindingFlags.NonPublic);
         return handle;
       }
     }
     #endregion
-    
+
     [StorableConstructor]
     private FieldDescriptor(bool deserializing) { }
Index: branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/Storable/Descriptors/HookDescriptor.cs
===================================================================
--- branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/Storable/Descriptors/HookDescriptor.cs	(revision 6220)
+++ branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/Storable/Descriptors/HookDescriptor.cs	(revision 6221)
@@ -20,9 +20,6 @@
 #endregion
 using System;
-using System.Collections.Generic;
-using System.Linq;
 using System.Reflection;
 using System.Text;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Persistence.Auxiliary;
 
@@ -54,5 +51,5 @@
     public HookType HookType { get; set; }
 
-    private MethodInfo handle;
+    internal MethodInfo handle;
     /// <summary>
     /// The MethodInfo of the hook as obtained by reflection.
@@ -60,12 +57,7 @@
     public MethodInfo Handle {
       get {
-        try {
-          if (handle == null)
-            handle = DeclaringType.Handle.GetMethod(MethodName, BindingFlags.Instance | BindingFlags.Public | BindingFlags.NonPublic, null, Type.EmptyTypes, null);
-        } catch { }
+        if (handle == null)
+          handle = DeclaringType.Handle.GetMethod(MethodName, BindingFlags.Instance | BindingFlags.Public | BindingFlags.NonPublic, null, Type.EmptyTypes, null);
         return handle;
-      }
-      internal set {
-        handle = value;
       }
     }
Index: branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/Storable/Descriptors/PropertyDescriptor.cs
===================================================================
--- branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/Storable/Descriptors/PropertyDescriptor.cs	(revision 6220)
+++ branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/Storable/Descriptors/PropertyDescriptor.cs	(revision 6221)
@@ -21,9 +21,6 @@
 
 using System;
-using System.Collections.Generic;
-using System.Linq;
 using System.Reflection;
 using System.Text;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Persistence.Default.CompositeSerializers.Storable.Descriptors {
@@ -35,4 +32,5 @@
   public sealed class PropertyDescriptor : ITypeComponent {
 
+    #region Fields & Properties
     /// <summary>
     /// The type descriptor of the type who declared this property. This
@@ -82,6 +80,5 @@
     public string Name { get { return StoredName ?? RealName; } }
 
-    #region Activation
-    private PropertyInfo handle;
+    internal PropertyInfo handle;
     /// <summary>
     /// The PropertyInfo object as obtained by reflection representing
@@ -90,13 +87,8 @@
     public PropertyInfo Handle {
       get {
-        try {
-          if (handle == null)
-            handle = DeclaringType.Handle.GetProperty(RealName, BindingFlags.Instance | BindingFlags.Public | BindingFlags.NonPublic);
-        } catch { }
+        if (handle == null)
+          handle = DeclaringType.Handle.GetProperty(RealName, BindingFlags.Instance | BindingFlags.Public | BindingFlags.NonPublic);
         return handle;
       }
-      internal set {
-        handle = value;
-      } 
     }
     #endregion
@@ -119,5 +111,5 @@
 
     [StorableConstructor]
-    private PropertyDescriptor(bool deserializing)  { }
+    private PropertyDescriptor(bool deserializing) { }
 
     /// <summary>
@@ -136,5 +128,5 @@
       CanRead = propertyInfo.CanRead;
       CanWrite = propertyInfo.CanWrite;
-      Handle = propertyInfo;
+      handle = propertyInfo;
     }
 
Index: branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/Storable/Descriptors/TypeDescriptor.cs
===================================================================
--- branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/Storable/Descriptors/TypeDescriptor.cs	(revision 6220)
+++ branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/Storable/Descriptors/TypeDescriptor.cs	(revision 6221)
@@ -91,5 +91,5 @@
     public bool IsInvalid { get; set; }
 
-    private Type handle;
+    internal Type handle;
     /// <summary>
     /// Get the System.Type handle representing this type.
@@ -97,12 +97,7 @@
     public Type Handle {
       get {
-        if (handle != null)
-          return handle;
-        try {
+        if (handle == null)
           handle = Type.GetType(AssemblyQualifiedName);
-          return handle;
-        } catch {
-          return null;
-        }
+        return handle;
       }
     }