Index: /branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/Storable/StorableClassAnalyzer.cs
===================================================================
--- /branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/Storable/StorableClassAnalyzer.cs	(revision 6223)
+++ /branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/Storable/StorableClassAnalyzer.cs	(revision 6224)
@@ -119,7 +119,5 @@
         return;
       var attribute = (StorableAttribute)fieldInfo.GetCustomAttributes(typeof(StorableAttribute), false).SingleOrDefault();
-      if (attribute != null && classAttribute.Type != StorableClassType.AllProperties ||
-        classAttribute.Type == StorableClassType.AllFields ||
-        classAttribute.Type == StorableClassType.AllFieldsAndAllProperties)
+      if (attribute != null)
         typeDescriptor.Fields.Add(new FieldDescriptor(typeDescriptor, fieldInfo, attribute));
     }
@@ -131,9 +129,6 @@
       }
       var attribute = (StorableAttribute)propertyInfo.GetCustomAttributes(typeof(StorableAttribute), false).SingleOrDefault();
-      if (attribute != null && classAttribute.Type != StorableClassType.AllFields ||
-        classAttribute.Type == StorableClassType.AllProperties ||
-        classAttribute.Type == StorableClassType.AllFieldsAndAllProperties) {
-        if (!(attribute != null && attribute.AllowOneWay ||
-             propertyInfo.CanRead && propertyInfo.CanWrite))
+      if (attribute != null) {
+        if (!(attribute.AllowOneWay || propertyInfo.CanRead && propertyInfo.CanWrite))
           throw new PersistenceException("Properties have to be read/write or marked as one way storable");
         typeDescriptor.Properties.Add(new PropertyDescriptor(typeDescriptor, propertyInfo, attribute));
Index: /branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/Storable/StorableClassAttribute.cs
===================================================================
--- /branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/Storable/StorableClassAttribute.cs	(revision 6223)
+++ /branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/Storable/StorableClassAttribute.cs	(revision 6224)
@@ -30,18 +30,4 @@
   public sealed class StorableClassAttribute : Attribute {
 
-
-    /// <summary>
-    /// Specify how members are selected for serialization.
-    /// </summary>
-    public StorableClassType Type { get; private set; }
-
-    /// <summary>
-    /// Mark a class to be serialize by the <c>StorableSerizlier</c>
-    /// </summary>
-    /// <param name="type">The storable class type.</param>
-    public StorableClassAttribute(StorableClassType type) {
-      Type = type;
-    }
-
     /// <summary>
     /// Initializes a new instance of the <see cref="StorableClassAttribute"/> class.
@@ -51,14 +37,4 @@
     public StorableClassAttribute() { }
 
-    /// <summary>
-    ///  Checks if the <see cref="StorableClassAttribute"/> is present on a type.
-    /// </summary>
-    /// <param name="type">The type which should be checked for the <see cref="StorableClassAttribute"/></param>
-    /// <returns></returns>
-    public static bool IsStorableClass(Type type) {
-      object[] attribs = type.GetCustomAttributes(typeof(StorableClassAttribute), false);
-      return attribs.Length > 0;
-    }
-
   }
 }
Index: anches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/Storable/StorableClassType.cs
===================================================================
--- /branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Default/CompositeSerializers/Storable/StorableClassType.cs	(revision 6223)
+++ 	(revision )
@@ -1,62 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-
-namespace HeuristicLab.Persistence.Default.CompositeSerializers.Storable {
-
-  /// <summary>
-  /// Specifies which memebrs are selected for serialization by the StorableSerializer
-  /// </summary>
-  public enum StorableClassType {
-
-    /// <summary>
-    /// Serialize only fields and properties that have been marked
-    /// with the [Storable] attribute. This is the default value.
-    /// </summary>
-    MarkedOnly,
-
-    /// <summary>
-    /// Serialize all fields but ignore the 
-    /// [Storable] attribute on properties.
-    /// 
-    /// This does not include generated backing fields
-    /// for automatic properties.
-    /// </summary>    
-    AllFields,
-
-    /// <summary>
-    /// Serialize all properties but ignore the
-    /// [Storable] attribute on fields.
-    /// </summary>    
-    AllProperties,
-
-    /// <summary>
-    /// Serialize all fields and all properties
-    /// regardless of the [Storable] attribute.
-    /// 
-    /// This does not include generated backing fields
-    /// for automatic properties, but uses the property
-    /// accessors instead.
-    /// </summary>    
-    AllFieldsAndAllProperties
-  };
-}
-
Index: /branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/HeuristicLab.Persistence-3.3.csproj
===================================================================
--- /branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/HeuristicLab.Persistence-3.3.csproj	(revision 6223)
+++ /branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/HeuristicLab.Persistence-3.3.csproj	(revision 6224)
@@ -154,5 +154,4 @@
     <Compile Include="Default\CompositeSerializers\NumberEnumerable2StringSerializer.cs" />
     <Compile Include="Default\CompositeSerializers\StackSerializer.cs" />
-    <Compile Include="Default\CompositeSerializers\Storable\StorableClassType.cs" />
     <Compile Include="Default\CompositeSerializers\Storable\StorableClassAttribute.cs" />
     <Compile Include="Default\CompositeSerializers\Storable\StorableAttribute.cs" />
Index: /branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Tests/UseCases.cs
===================================================================
--- /branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Tests/UseCases.cs	(revision 6223)
+++ /branches/PersistenceSpeedUp/HeuristicLab.Persistence/3.3/Tests/UseCases.cs	(revision 6224)
@@ -921,93 +921,6 @@
     }
 
-    [StorableClass(StorableClassType.AllFields)]
-    public class AllFieldsStorable {
-      public int Value1 = 1;
-      [Storable]
-      public int Value2 = 2;
-      public int Value3 { get; private set; }
-      public int Value4 { get; private set; }
-      [StorableConstructor]
-      public AllFieldsStorable(bool isDeserializing) {
-        if (!isDeserializing) {
-          Value1 = 12;
-          Value2 = 23;
-          Value3 = 34;
-          Value4 = 56;
-        }
-      }
-    }
-
-    [TestMethod]
-    public void TestStorableClassDiscoveryAllFields() {
-      AllFieldsStorable afs = new AllFieldsStorable(false);
-      XmlGenerator.Serialize(afs, tempFile);
-      AllFieldsStorable newAfs = (AllFieldsStorable)XmlParser.Deserialize(tempFile);
-      Assert.AreEqual(afs.Value1, newAfs.Value1);
-      Assert.AreEqual(afs.Value2, newAfs.Value2);
-      Assert.AreEqual(0, newAfs.Value3);
-      Assert.AreEqual(0, newAfs.Value4);
-    }
-
-    [StorableClass(StorableClassType.AllProperties)]
-    public class AllPropertiesStorable {
-      public int Value1 = 1;
-      [Storable]
-      public int Value2 = 2;
-      public int Value3 { get; private set; }
-      public int Value4 { get; private set; }
-      [StorableConstructor]
-      public AllPropertiesStorable(bool isDeserializing) {
-        if (!isDeserializing) {
-          Value1 = 12;
-          Value2 = 23;
-          Value3 = 34;
-          Value4 = 56;
-        }
-      }
-    }
-
-    [TestMethod]
-    public void TestStorableClassDiscoveryAllProperties() {
-      AllPropertiesStorable afs = new AllPropertiesStorable(false);
-      XmlGenerator.Serialize(afs, tempFile);
-      AllPropertiesStorable newAfs = (AllPropertiesStorable)XmlParser.Deserialize(tempFile);
-      Assert.AreEqual(1, newAfs.Value1);
-      Assert.AreEqual(2, newAfs.Value2);
-      Assert.AreEqual(afs.Value3, newAfs.Value3);
-      Assert.AreEqual(afs.Value4, newAfs.Value4);
-
-    }
-
-    [StorableClass(StorableClassType.AllFieldsAndAllProperties)]
-    public class AllFieldsAndAllPropertiesStorable {
-      public int Value1 = 1;
-      [Storable]
-      public int Value2 = 2;
-      public int Value3 { get; private set; }
-      public int Value4 { get; private set; }
-      [StorableConstructor]
-      public AllFieldsAndAllPropertiesStorable(bool isDeserializing) {
-        if (!isDeserializing) {
-          Value1 = 12;
-          Value2 = 23;
-          Value3 = 34;
-          Value4 = 56;
-        }
-      }
-    }
-
-    [TestMethod]
-    public void TestStorableClassDiscoveryAllFieldsAndAllProperties() {
-      AllFieldsAndAllPropertiesStorable afs = new AllFieldsAndAllPropertiesStorable(false);
-      XmlGenerator.Serialize(afs, tempFile);
-      AllFieldsAndAllPropertiesStorable newAfs = (AllFieldsAndAllPropertiesStorable)XmlParser.Deserialize(tempFile);
-      Assert.AreEqual(afs.Value1, newAfs.Value1);
-      Assert.AreEqual(afs.Value2, newAfs.Value2);
-      Assert.AreEqual(afs.Value3, newAfs.Value3);
-      Assert.AreEqual(afs.Value4, newAfs.Value4);
-    }
-
-    [StorableClass(StorableClassType.MarkedOnly)]
+
+    [StorableClass]
     public class MarkedOnlyStorable {
       public int Value1 = 1;