Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Controllers/QueryController.cs
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Controllers/QueryController.cs	(revision 6218)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Controllers/QueryController.cs	(revision 6226)
@@ -41,5 +41,7 @@
 
         public ActionResult RunCollectionTable() {
-            return View();
+            QueryModel qm = new QueryModel();
+            Session["QueryRuns"] = qm.getTestRuns();
+            return View(qm);
         }
     }
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/HLWebOKBQueryPlugin.csproj
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/HLWebOKBQueryPlugin.csproj	(revision 6218)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/HLWebOKBQueryPlugin.csproj	(revision 6226)
@@ -99,5 +99,8 @@
     </Compile>
     <Compile Include="Helpers\HtmlHelpers.cs" />
+    <Compile Include="Helpers\IParams.cs" />
+    <Compile Include="Helpers\IResult.cs" />
     <Compile Include="Helpers\Query.cs" />
+    <Compile Include="Helpers\RunCollectionData.cs" />
     <Compile Include="Models\AccountModels.cs" />
     <Compile Include="Models\ChartModel.cs" />
@@ -163,4 +166,5 @@
     <EmbeddedResource Include="Views\Query\Menu.ascx" />
     <Content Include="Views\Query\Results.aspx" />
+    <EmbeddedResource Include="Views\Query\RunCollectionTable.ascx" />
     <Content Include="Views\ServiceTest\Index.aspx" />
     <Content Include="Web.config">
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Helpers/Query.cs
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Helpers/Query.cs	(revision 6218)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Helpers/Query.cs	(revision 6226)
@@ -17,6 +17,6 @@
             try {
                 QueryServiceClient client = new QueryServiceClient();
-                client.ClientCredentials.UserName.UserName = username;
-                client.ClientCredentials.UserName.Password = password;
+                client.ClientCredentials.UserName.UserName = "okbtester";
+                client.ClientCredentials.UserName.Password = "okbtester";
                 client.ClientCredentials.ServiceCertificate.Authentication.CertificateValidationMode = X509CertificateValidationMode.None;
                 client.GetFilters();
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Helpers/RunCollectionData.cs
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Helpers/RunCollectionData.cs	(revision 6218)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Helpers/RunCollectionData.cs	(revision 6226)
@@ -10,4 +10,7 @@
 
         #region properties
+        // Run
+        public long Id { get; set; }
+
         // Result
         public string ExecutionTime { get; set; }
@@ -64,4 +67,5 @@
         #region constructor/initialisation
         public RunCollectionData(Run run) {
+            Id = run.Id;
 
             // results
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Models/QueryModel.cs
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Models/QueryModel.cs	(revision 6218)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Models/QueryModel.cs	(revision 6226)
@@ -29,26 +29,26 @@
         }
 
-        //// just 4 testing
-        //public IList<RunCollectionData> getTestRuns() {
+        // just 4 testing
+        public IList<RunCollectionData> getTestRuns() {
 
-        //    QueryServiceClient client = Query.GetClientFactory();
+            QueryServiceClient client = Query.GetClientFactory();
 
-        //    if (client != null) {
-        //        IList<RunCollectionData> runs = new List<RunCollectionData>();
+            if (client != null) {
+                IList<RunCollectionData> runs = new List<RunCollectionData>();
 
-        //        //long[] runIds = client.GetRunIds(new Filter());
-        //        //if (runIds.Length < cnt) cnt = runIds.Length;
+                //long[] runIds = client.GetRunIds(new Filter());
+                //if (runIds.Length < cnt) cnt = runIds.Length;
 
-        //        long[] getRuns = new long[2]{1,2};
+                long[] getRuns = new long[2] { 1, 2 };
 
-        //        IList<Run> runList = client.GetRuns(getRuns, false).ToList<Run>();
+                IList<Run> runList = client.GetRuns(getRuns, false).ToList<Run>();
 
-        //        foreach (Run r in runList) 
-        //            runs.Add(new RunCollectionData(r));
+                foreach (Run r in runList)
+                    runs.Add(new RunCollectionData(r));
 
-        //        return runs;
-        //    }
-        //    return new List<RunCollectionData>();
-        //}
+                return runs;
+            }
+            return new List<RunCollectionData>();
+        }
     }
 }
Index: branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/RunCollectionTable.ascx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/RunCollectionTable.ascx	(revision 6218)
+++ branches/WebApplication/MVC2/HLWebOKBQueryPlugin/Views/Query/RunCollectionTable.ascx	(revision 6226)
@@ -1,19 +1,37 @@
 ﻿<%@ Control Language="C#" Inherits="System.Web.Mvc.ViewUserControl" %>
+<%@ Import Namespace="HLWebOKBQueryPlugin.Helpers" %>
+<%@ Import Namespace="System.Reflection" %>
 
 <div id="RunCollectionTable" style="overflow: auto; width: 100%">
-    <form id="frmRunCollectionTable" runat="server" method="post">
+    <table>
+        <thead>
+            <tr>
+                <th>&nbsp;</th>
+                <% foreach (PropertyInfo pi in typeof(RunCollectionData).GetProperties()) { %>
+                <th><%= pi.Name %></th>
+                <% } %>
+            </tr>
+        </thead>
+        <tbody>
+            <% IList<RunCollectionData> data = (IList<RunCollectionData>) Session["QueryRuns"];
+               foreach (RunCollectionData rcd in data) { 
+                   RouteValueDictionary rvd = new RouteValueDictionary();
+                   rvd.Add("controller", "Query");
+                   rvd.Add("id", rcd.Id);
+                   %>
+                <tr>
+                    <td><%: Html.ActionLink("details", "Details", rvd) %></td>
 
-        <asp:GridView ID="GridRunCollection" runat="server" DataSourceID="dsQueryRuns">
-            <SelectedRowStyle BackColor="Aqua" />
-            <Columns>
-                <asp:BoundField />
-                <asp:CommandField ShowSelectButton="true" SelectText="Details" />
-            </Columns>
-        </asp:GridView>
-        <asp:ObjectDataSource ID="dsQueryRuns" runat="server" 
-                    SelectMethod="getTestRuns" 
-                    TypeName="HLWebPluginHost.Models.QueryModel">
-        </asp:ObjectDataSource>
+                    <% foreach (PropertyInfo pi in typeof(RunCollectionData).GetProperties()) {
+                           try { %>
+                    <td><%= pi.GetValue(rcd, null).ToString()%></td>
+                    <%     } catch (Exception e) { %>
+                        &nbsp;</td>
+                    <%     }
+                       } %>
+                </tr>
+               <% } %>
+        </tbody>
+    </table>
 
-    </form>
 </div>